#!/bin/sh
# FritzBox.sh
# Version 0.8.3
# 
# ----------------------------------------------------------------------

# User sollte in der Fritz!Box die Expertenansicht aktiviert haben

temp="/tmp"
Debug="1"										# mit "0" deaktivieren, wenn nicht mehr benötigt

# Konfiguration auch in der FritzBox.cfg ########
												#
config(){										#
IP=""											# Bevorzugt die IP-Adresse verwenden
Username=""										# FB-Login mit user/password verwenden
Passwd=""										#
}												#
ANRUFLIST="$temp/FritzBox_anruferliste.csv"		#
												#
# ab hier bitte nichts mehr ändern ##############


# Config-Methode
#if [ $1 != "x" ]; then
#	CONFIGFILE="/usr/local/addons/cuxd/user/FritzBox.cfg"
#	if [ -f "$CONFIGFILE" ];then 
#      source $CONFIGFILE
#	else 
#      config
#	fi
if [ $1 != "x" ]; then
	config
	CONFIGFILE="/usr/local/addons/cuxd/user/FritzBox.cfg"
	# Lese CONFIGFILE und ersetzen KEY: Value
	eval `sed '/^ *#/d;s/:/ /;' < "$CONFIGFILE" | while read key val
	do
    str="$key='$val'"
    echo "$str"
	done`
else											# sh FritzBox.sh {x [IP] [Username|-] [Passwd]} ...
	IP=$2
	if [ $3 = "-" ]; then
		Username=""
	else
		Username=$3
	fi
	Passwd=$4
	shift #$1
	shift #$2
	shift #$3
	shift #$4
fi

# Alle Debugnachrichten Nachrichten
Debugmsg="FritzBox.sh 0.8.3 \n"

ID=$(date "+%M%S"$RANDOM)
HOMEMATIC="127.0.0.1"
FritzBoxURL="http://$IP"
ADDONDIR="/usr/local/addons/cuxd"
FRITZLOGIN="/login_sid.lua"
FRITZWEBCM="/cgi-bin/webcm"
FRITZHOME="/home/home.lua"
AHAURL="$FritzBoxURL/webservices/homeautoswitch.lua"
DebugFile="$temp/FritzBox_$IP-debug.log"
TEMPFile="$temp/FritzBox_$IP-temp_$ID.txt"
CURLFile="$temp/FritzBox_$IP-curlfile.html"
devicesFBAHA="$temp/FritzBox_$IP-devicesFBAHA.xml"
tempAB="$temp/FritzBox_$IP-AB.txt"
FritzOS_tmp="$temp/FritzBox_$IP-FritzOS.txt"
network_user_devices="$temp/FritzBox_$IP-network_user_devices.txt"


# Wie werden die Webseiten aufgerufen
WEBCLIENT="/usr/local/addons/cuxd/curl -s"

CPWMD5=/usr/local/addons/cuxd/user/cpwmd5			# wird bei der CCU1 automatisch installiert
install(){
Debugmsg=$Debugmsg"Installiere CPWMD5... \n"
test -r "$CPWMD5" || cat << 'EOF' >"$CPWMD5"
#!/bin/tclsh
package require md5
proc md5 {str} {
  string tolower [::md5::md5 -hex $str]
}
proc utf16 {str} {
  encoding convertto unicode $str
}
puts [md5 [utf16 [lindex $argv 0]]]
EOF
chmod 755 $CPWMD5
Debugmsg=$Debugmsg"...CPWMD5 installiert. \n"
}

# Parameter 1: POST/GET Daten 
# Parameter 2: (default POST) GET -> Get request
# Parameter 3: Servlet (default FRITZWEBCM) 
PerformPOST(){
	local loggingfile="/dev/null"
	if [ $Debug = "1" ]; then
		loggingfile=$CURLFile
		Debugmsg=$Debugmsg"GET/POST wird protokolliert in $CURLFile \n"
	fi
	# Parameter 3 ueberpruefen (URL)
	if [ "$3" = "" ]; then
		local URL=$FritzBoxURL$FRITZWEBCM
	else
		local URL=$FritzBoxURL$3
	fi
	# Parameter 2 ueberpruefen (POST oder GET)
	if [ "$2" = "GET" ]; then
		Debugmsg=$Debugmsg"GET  : $1 \n"
		Debugmsg=$Debugmsg"GET  : URL $URL?$1 \n"
		$WEBCLIENT "$URL?$1" >$loggingfile
		Debugmsg=$Debugmsg"GET : Abgesendet \n"
	else
		Debugmsg=$Debugmsg"POST : $1 \n"
		Debugmsg=$Debugmsg"POST : $URL \n"
		$WEBCLIENT -d "$1" "$URL" >$loggingfile
		Debugmsg=$Debugmsg"POST : Abgesendet \n"
	fi
}

EndFritzBoxSkript() {
	read FritzOS < $FritzOS_tmp
	local exitcode=$1
	local debugmessage=$2
	if [ $Debug = "1" ]; then
# Ausgabe in Komandozeile
		echo -e "$0 EndFritzBoxSkript() 
		FritzOS : $FritzOS
		EXITCODE: $exitcode
		MESSAGE : $debugmessage
		LOGGING : Messages so far captured:
		$Debugmsg"
# Logging in Debugfile
		echo -e "$0 EndFritzBoxSkript()
		FritzOS : $FritzOS
		EXITCODE: $exitcode
		MESSAGE : $debugmessage
		LOGGING Messages so far captured: 
		$Debugmsg" > $DebugFile
	fi
	echo $exitcode $debugmessage
	exit $exitcode
}

LOGIN(){
	# Downlod Login XML nach TempFile
	$WEBCLIENT "$FritzBoxURL$FRITZLOGIN">$TEMPFile
	SessionInfoChallenge=$(sed -n '/.*<Challenge>\([^<]*\)<.*/s//\1/p' $TEMPFile)
	SessionInfoSID=$(sed -n '/.*<SID>\([^<]*\)<.*/s//\1/p' $TEMPFile)
	Debugmsg=$Debugmsg"LOGIN: Challenge $SessionInfoChallenge \n"
	Debugmsg=$Debugmsg"LOGIN: SID       $SessionInfoSID \n"
	if [ "$SessionInfoSID" = "0000000000000000" ]; then
		Debugmsg=$Debugmsg"LOGIN: Keine gueltige SID - Login aufbauen \n"
		if [ "$RANDOM" != "" ]; then
			Debugmsg=$Debugmsg"LOGIN: CCU2\n"
			MD5="$(echo -n "$SessionInfoChallenge-$Passwd" | sed -e 's,.,&\n,g' | tr '\n' '\0' | md5sum)"
			RESPONSE=$SessionInfoChallenge-${MD5%% *}
		else
			Debugmsg=$Debugmsg"LOGIN: CCU1\n"
			test -r "$CPWMD5" || install 
			CPSTR="$SessionInfoChallenge-$Passwd"
			MD5=`$CPWMD5 $CPSTR`
			RESPONSE="$SessionInfoChallenge-$MD5" 			
		fi
		Debugmsg=$Debugmsg"LOGIN: login senden und SID herausfischen \n"
		GETDATA="?username=$Username&response=$RESPONSE"
		Debugmsg=$Debugmsg"LOGIN: $GETDATA \n"
		$WEBCLIENT "$FritzBoxURL$FRITZLOGIN$GETDATA">$TEMPFile
		SID=$(sed -n '/.*<SID>\([^<]*\)<.*/s//\1/p' $TEMPFile)
		rm $TEMPFile
		find $temp/ -name "FritzBox_$IP-temp_*" -mmin +300 -print0 | xargs -0 rm -f
	else
		SID=$SessionInfoSID
		Debugmsg=$Debugmsg"LOGIN: Bereits erfolgreiche SID: $SID \n"
	fi
	if [ "$SID" = "0000000000000000" ]; then
		Debugmsg=$Debugmsg"LOGIN: ERROR - Konnte keine gueltige SID ermitteln \n"
		EndFritzBoxSkript 3 "Keine-gueltige-Anmeldung-moeglich-PassWortoderUser-falsch"
	else
		Debugmsg=$Debugmsg"LOGIN: Gueltige SID: $SID \n"
	fi
}

SetCCUVariable(){
	Debugmsg=$Debugmsg"SetCCUVariable $1 $2 \n"
	if [ "$2" != "" ]; then
		Debugmsg=$Debugmsg"http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27$1%27%29.State%28%22$2%22%29 \n"
		$WEBCLIENT "http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27$1%27%29.State%28%22$2%22%29"	
	else
		Debugmsg=$Debugmsg"$IP -> SetCCUVariable: $1 - Fehler, keine Status.\n"
		logger -i -t $0 -p 3 "$IP -> SetCCUVariable: $1 - Fehler, keine Status."
	fi
}
set_CUxD_state(){
	if [ $1 != "" ]; then
		Debugmsg=$Debugmsg"set_CUxD_state $2/$3 $4 \n"
		Debugmsg=$Debugmsg"http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27CUxD.$3.SET_STATE%27%29.State%28%22$4%22%29 \n"
		$WEBCLIENT "http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27CUxD.$3.SET_STATE%27%29.State%28%22$4%22%29"	
	else
		Debugmsg=$Debugmsg"$IP -> set_CUxD_state: $2/$3 - Fehler, keine Status.\n"
		logger -i -t $0 -p 3 "$IP -> set_CUxD_state: $2/$3 - Fehler, keine Status."
	fi
}
set_CUxD_temperature(){
	if [ $1 != "" ] ; then
		Debugmsg=$Debugmsg"set_CUxD_temperature $3 $response_Celsius \n"
		Debugmsg=$Debugmsg"http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27CUxD.$3.SET_TEMPERATURE%27%29.State%28%22$response_Celsius%22%29 \n"
		$WEBCLIENT "http://$HOMEMATIC:8181/FritzBox.exe?Status=dom.GetObject%28%27CUxD.$3.SET_TEMPERATURE%27%29.State%28%22$response_Celsius%22%29"	
	else
		Debugmsg=$Debugmsg"$IP -> set_CUxD_temperature: $2/$3 - Fehler, keine Status.\n"
		logger -i -t $0 -p 3 "$IP -> set_CUxD_temperature: $2/$3 - Fehler, keine Status."
	fi
}


get_WLAN_state(){		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/wlan/wlan_settings.lua?sid=$SID \n"
#echo -n $($WEBCLIENT "$FritzBoxURL/wlan/wlan_settings.lua?sid=$SID" | grep '"wlan:settings/ap_enabled"' | tr -cd [:digit:]) > $stateWLAN
stateWLAN=$($WEBCLIENT "$FritzBoxURL/wlan/wlan_settings.lua?sid=$SID" | grep '"wlan:settings/ap_enabled"' | tr -cd [:digit:])
}                                                                 

get_WLAN5_state(){ 		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/wlan/wlan_settings.lua?sid=$SID \n"
stateWLAN5=$($WEBCLIENT "$FritzBoxURL/wlan/wlan_settings.lua?sid=$SID" | grep '"wlan:settings/ap_enabled_scnd"' | tr -cd [:digit:])
}

get_WLANGast_state(){ 	# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/wlan/wlan_settings.lua?sid=$SID \n"
# status=$($WEBCLIENT "$FritzBoxURL/wlan/wlan_settings.lua?sid=$SID" | grep 'wlan:settings/guest_ap_enabled')
stateWLANGast=$($WEBCLIENT "$FritzBoxURL/wlan/guest_access.lua?sid=$SID" | grep '"wlan:settings/guest_ap_enabled"' | tr -cd [:digit:])
}

get_DECT_state(){ 		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/dect/dect_settings.lua?sid=$SID \n"
stateDECT=$($WEBCLIENT "$FritzBoxURL/dect/dect_settings.lua?sid=$SID" | grep '"dect:settings/enabled"' | tr -cd [:digit:])
}

get_UMTS_state(){		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/umts_settings.lua?sid=$SID \n"
stateUMTS=$($WEBCLIENT "$FritzBoxURL/internet/umts_settings.lua?sid=$SID" | grep '"umts:settings/enabled"' | tr -cd [:digit:])
}

get_CallThrough_state(){		# 0 / 1
Debugmsg=$Debugmsg"URL: $FritzBoxURL/fon_num/callthrough.lua?sid=$SID \n"
stateCallThrough=$($WEBCLIENT "$FritzBoxURL/fon_num/callthrough.lua?sid=$SID" | grep '"telcfg:settings/CallThrough/Active"' | tr -cd [:digit:])
}

get_FBAHA_state(){ 		# 0 / 1 / inval
Debugmsg=$Debugmsg"URL: $AHAURL?ain=$AIN&switchcmd=getswitchstate&sid=$SID \n"	
stateFBAHA=$($WEBCLIENT "$AHAURL?ain=$AIN&switchcmd=getswitchstate&sid=$SID")
}
get_FBAHA_present(){ 	# 0 / 1
Debugmsg=$Debugmsg"URL: $AHAURL?ain=$AIN&switchcmd=getswitchpresent&sid=$SID \n"	
presentFBAHA=$($WEBCLIENT "$AHAURL?ain=$AIN&switchcmd=getswitchpresent&sid=$SID")
}
get_FBAHA_DEVICE_state(){
if [ -f $devicesFBAHA ]; then
	find $temp/ -name "FritzBox_$IP-devicesFBAHA.xml" -mmin +2 -print0 | xargs -0 rm
	Debugmsg=$Debugmsg"$IP -> FBAHA: Daten prüfen \n"	
fi
if [ -f $devicesFBAHA ]; then
	Debugmsg=$Debugmsg"$IP -> FBAHA: Daten vorhanden \n"
else
	Debugmsg=$Debugmsg"$IP -> FBAHA: Daten holen ($AHAURL?&switchcmd=getdevicelistinfos&sid=$SID) \n"	
	echo -n $($WEBCLIENT "$AHAURL?switchcmd=getdevicelistinfos&sid=$SID" | sed 's|[" ]||g' ) > $devicesFBAHA
fi
response_Name=$(sed -n "/deviceidentifier=$AIN/{s/.*<deviceidentifier=$AIN//;s/<\/device.*//;p;}" $devicesFBAHA | sed -n 's:.*<name>\(.*\)</name>.*:\1:p' )

get_FBAHA_Celsius=$(sed -n "/deviceidentifier=$AIN/{s/.*<deviceidentifier=$AIN//;s/<\/device.*//;p;}" $devicesFBAHA | sed -n 's:.*<celsius>\(.*\)</celsius>.*:\1:p' )
response_Celsius=$(printf "%.2i\n" $get_FBAHA_Celsius | sed -e "s:.$:.&:g")

get_FBAHA_Power=$(sed -n "/deviceidentifier=$AIN/{s/.*<deviceidentifier=$AIN//;s/<\/device.*//;p;}" $devicesFBAHA | sed -n 's:.*<power>\(.*\)</power>.*:\1:p' )
response_Power=$(printf "%.4i\n" $get_FBAHA_Power | sed -e "s:...$:.&:g")

Debugmsg=$Debugmsg"\nGerät: $response_Name / $AIN \n\nPower: $get_FBAHA_Power = $response_Power Watt\nTemperatur: $get_FBAHA_Celsius = $response_Celsius °C\n"	
}

get_AB_temp(){
echo -n $($WEBCLIENT "$FritzBoxURL/fon_devices/tam_list.lua?sid=$SID" | grep '"Active"' -B1| sed -e 's/{//g' -e 's/-//g' -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' ) > $tempAB
Debugmsg=$Debugmsg"$IP -> AB: Daten holen ($FritzBoxURL/fon_devices/tam_list.lua?sid=$SID) \n"
}
get_AB_state(){
if [ -f $tempAB ]; then
	find $temp/ -name "FritzBox_$IP-AB.txt" -mmin +1 -print0 | xargs -0 rm -f
	Debugmsg=$Debugmsg"$IP -> AB: Daten prüfen \n"	
fi
if [ -f $tempAB ]; then
	Debugmsg=$Debugmsg"$IP -> AB: Daten vorhanden \n"
else
	LOGIN
	get_AB_temp
fi
idAB=$(($1+1))
stateAB=$(sed 's/,/\n/g' $tempAB | grep "\[$idAB\]" )
Debugmsg=$Debugmsg"AB: $stateAB \n"
if echo $stateAB | grep -q "Active = 1" ; then 
	stateAB=1
	Debugmsg=$Debugmsg"Status-AB $idAB: aktiv ($stateAB)\n"
else
	stateAB=0
	Debugmsg=$Debugmsg"Status-AB $idAB: deaktiviert ($stateAB)\n"
fi
}

get_network_user_devices(){
if [ -f $network_user_devices ]; then
	find $temp/ -name "FritzBox_$IP-network_user_devices.txt" -mmin +3 -print0 | xargs -0 rm -f
	Debugmsg=$Debugmsg"$IP -> network_user_devices: Daten prüfen \n"	
fi
if [ -f $network_user_devices ]; then
	Debugmsg=$Debugmsg"$IP -> network_user_devices: Daten vorhanden \n"
else
	LOGIN
	#echo -n "$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | sed -n "/<pre>/,/<\/pre>/p" )" > $network_user_devices
	echo -n "$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | sed -n "/<pre>/,/<\/pre>/p" | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' )" > $network_user_devices	
#	echo -n "$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | grep '"_node"] = "landevice' -A27 -B2 | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' )" > $network_user_devices
	Debugmsg=$Debugmsg"$IP -> network_user_devices: Daten holen ($FritzBoxURL/net/network_user_devices.lua?sid=$SID) \n"
fi
}

get_FONuser(){
	FONuser=$($WEBCLIENT "$FritzBoxURL/dect/dect_list.lua?sid=$SID" | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' | grep "Intern = $1" -A4 | grep '_node' | sed 's/.*\(.\{1\}\)$/\1/' )
	Debugmsg=$Debugmsg"$FritzBoxURL/dect/dect_list.lua?sid=$SID\nFON=$1 / user=$FONuser\n"
}

get_FritzOS(){
if [ -f $FritzOS_tmp ]; then
	find $temp/ -name "FritzBox_$IP-FritzOS.txt" -mtime +7 -print0 | xargs -0 rm -f
	Debugmsg=$Debugmsg"$IP -> FritzOS: Daten prüfen \n"	
fi
if [ -f $FritzOS_tmp ]; then
	Debugmsg=$Debugmsg"$IP -> FritzOS: Daten vorhanden \n"
else
	LOGIN
	echo -n "$($WEBCLIENT "$FritzBoxURL/system/update.lua?sid=$SID" | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' | grep "logic:status/nspver" | sed -e 's/\ //g' | sed "s|.*=\(.*\),.*|\\1|")" > $FritzOS_tmp
	Debugmsg=$Debugmsg"$IP -> FritzOS: Daten holen ($FritzBoxURL/system/update.lua?sid=$SID) \n"
fi
}

# Debug Setzte alle Parameter für Logfile
Debugmsg=$Debugmsg"Parameter HOMEMATIC    = $HOMEMATIC \n"
Debugmsg=$Debugmsg"Parameter ADDONDIR     = $ADDONDIR \n"
Debugmsg=$Debugmsg"Parameter CONFIGFILE   = $CONFIGFILE \n"
Debugmsg=$Debugmsg"Parameter FRITZLOGIN   = $FRITZLOGIN\n"
Debugmsg=$Debugmsg"Parameter FRITZWEBCM   = $FRITZWEBCM \n"
Debugmsg=$Debugmsg"Parameter FRITZHOME    = $FRITZHOME \n"
Debugmsg=$Debugmsg"Parameter TEMPFile     = $TEMPFile \n"
Debugmsg=$Debugmsg"Parameter CURLFile     = $CURLFile \n"
Debugmsg=$Debugmsg"Parameter WEBCLIENT    = $WEBCLIENT \n"
Debugmsg=$Debugmsg"Parameter ANRUFLIST    = $ANRUFLIST \n"
Debugmsg=$Debugmsg"Parameter Debug        = $DebugFile \n"
Debugmsg=$Debugmsg"Parameter devicesFBAHA = $devicesFBAHA \n"
Debugmsg=$Debugmsg"Parameter tempAB       = $tempAB \n"
Debugmsg=$Debugmsg"Parameter FritzBoxURL  = $FritzBoxURL \n"
Debugmsg=$Debugmsg"Parameter Username     = $Username \n"
Debugmsg=$Debugmsg"Parameter Passwd       = $Passwd \n"

if [ "$Passwd" = "" ]; then
	EndFritzBoxSkript 1 "Passwort-nicht-gesetzt-CONF-Datei-pruefen"
fi	

# Wechsle in das Addonverzeichnis
export LD_LIBRARY_PATH=$ADDONDIR
cd $ADDONDIR/extra
get_FritzOS
Debugmsg=$Debugmsg"INFO:  Befehl $1 $2 $3 $4 \n"
case $1 in
	"test")  		LOGIN
					
				
					;;
	"FB-AHA")  		LOGIN
					AIN=$2
					if [ $3 = "0" ] ; then
						$WEBCLIENT "$AHAURL?ain=$AIN&switchcmd=setswitchoff&sid=$SID"
						Debugmsg=$Debugmsg"$AHAURL?ain=$AIN&switchcmd=setswitchoff&sid=$SID\n"
					elif [ $3 = "1" ] ; then
						$WEBCLIENT "$AHAURL?ain=$AIN&switchcmd=setswitchon&sid=$SID"
						Debugmsg=$Debugmsg"$AHAURL?ain=$AIN&switchcmd=setswitchon&sid=$SID\n"
					elif [ $3 = "state" ] ; then
						get_FBAHA_state
						set_CUxD_state "$stateFBAHA" $1 $4 $stateFBAHA
					elif [ $3 = "state1" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state "$stateFBAHA" $1 $4 $stateFBAHA
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							SetCCUVariable $4-Status $presentFBAHA
						else
							presentFBAHA=2
							SetCCUVariable $4-Status $presentFBAHA
						fi
					elif [ $3 = "state1-p" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state "$stateFBAHA" $1 $4 $stateFBAHA
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							SetCCUVariable $4-Status $presentFBAHA
						else
							presentFBAHA=2
							SetCCUVariable $4-Status $presentFBAHA
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Power != "" ] ; then
							SetCCUVariable $4-Leistung $response_Power
						else
							SetCCUVariable $4-Leistung
						fi
					elif [ $3 = "state1-t" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state "$stateFBAHA" $1 $4 $stateFBAHA
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							SetCCUVariable $4-Status $presentFBAHA
						else
							presentFBAHA=2
							SetCCUVariable $4-Status $presentFBAHA
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							SetCCUVariable $4-Temperatur $response_Celsius
						else
							SetCCUVariable $4-Temperatur
						fi
					elif [ $3 = "state1-pt" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state "$stateFBAHA" $1 $4 $stateFBAHA
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							SetCCUVariable $4-Status $presentFBAHA
						else
							presentFBAHA=2
							SetCCUVariable $4-Status $presentFBAHA
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							SetCCUVariable $4-Temperatur $response_Celsius
						else
							SetCCUVariable $4-Temperatur
						fi
						if [ $get_FBAHA_Power != "" ] ; then
							SetCCUVariable $4-Leistung $response_Power
						else
							SetCCUVariable $4-Leistung
						fi
					elif [ $3 = "state1-pts" ] ; then
						get_FBAHA_state
						get_FBAHA_present
						set_CUxD_state "$stateFBAHA" $1 $4 $stateFBAHA
						if [ $stateFBAHA != "" ] ; then
							SetCCUVariable $4-Schaltzustand $stateFBAHA
						else
							SetCCUVariable $4-Schaltzustand
						fi
						if [ $presentFBAHA = "0" ] || [ $presentFBAHA = "1" ] ; then
							SetCCUVariable $4-Status $presentFBAHA
						else
							presentFBAHA=2
							SetCCUVariable $4-Status $presentFBAHA
						fi
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							SetCCUVariable $4-Temperatur $response_Celsius
						else
							SetCCUVariable $4-Temperatur
						fi
						if [ $get_FBAHA_Power != "" ] ; then
							SetCCUVariable $4-Leistung $response_Power
						else
							SetCCUVariable $4-Leistung
						fi
					elif [ $3 = "power" ] ; then 
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Power != "" ] ; then
							SetCCUVariable $4-Leistung $response_Power
						else
							SetCCUVariable $4-Leistung
						fi
					elif [ $3 = "power1" ] ; then 
						get_FBAHA_DEVICE_state
						set_CUxD_state "$get_FBAHA_Power" $1 $4 $response_Power
					elif [ $3 = "temperature" ] ; then 
						get_FBAHA_DEVICE_state
						if [ $get_FBAHA_Celsius != "" ] ; then
							SetCCUVariable $4-Temperatur $response_Celsius
						else
							SetCCUVariable $4-Temperatur
						fi
					elif [ $3 = "temperature1" ] ; then 
						get_FBAHA_DEVICE_state
						set_CUxD_state "$get_FBAHA_Celsius" $1 $4 $response_Celsius
					elif [ $3 = "temperature2" ] ; then 
						get_FBAHA_DEVICE_state
						set_CUxD_temperature "$get_FBAHA_Celsius" $1 $4
					else
					logger -i -t $0 -p 3 "$IP -> $1: Fehler"
					fi
					;;
	"FON-alarm")	LOGIN				# sh FritzBox.sh FON-alarm 610 1 8 Hallo%20Welt
					Zeit=$(date +%H%M)
					Telefon=$(echo $2 | cut -c3- | sed -e "s:.$:6&:g")
					get_FONuser $2
					AlarmClock=$(($3-1))
					tone=$4
					Text="$5"
					PerformPOST "telcfg:settings/Foncontrol/User$FONuser/AlarmRingTone0=$tone&sid=$SID" "POST"
					PerformPOST "telcfg:settings/AlarmClock$AlarmClock/Active=1&sid=$SID" "POST"
					PerformPOST "telcfg:settings/AlarmClock$AlarmClock/Number=$Telefon&sid=$SID" "POST"
					PerformPOST "telcfg:settings/AlarmClock$AlarmClock/Name=$Text&sid=$SID" "POST"
					PerformPOST "telcfg:settings/AlarmClock$AlarmClock/Time=$Zeit&sid=$SID" "POST"
					PerformPOST "telcfg:settings/AlarmClock$AlarmClock/Weekdays=0&sid=$SID" "POST"
					PerformPOST "telcfg:settings/AlarmClock$AlarmClock/Active=0&sid=$SID" "POST"
					Debugmsg=$Debugmsg"Telefon: $2 = $Telefon\nText: $Text\n"
					;;
	"FON-RingTone")	LOGIN				# sh FritzBox.sh FON-RingTone 610 0 16   (16=lautlos, 3=standard)
					get_FONuser $2
					PerformPOST "telcfg:settings/Foncontrol/User$FONuser/MSN$3/RingTone=$4&sid=$SID" "POST"
					Debugmsg=$Debugmsg"telcfg:settings/Foncontrol/User$FONuser/MSN$3/RingTone=$4&sid=$SID"
					;;
	"FON-Name")		LOGIN				# sh FritzBox.sh FON-Name 610 Name
					get_FONuser $2
					PerformPOST "telcfg:settings/Foncontrol/User$FONuser/Name=$3&sid=$SID" "POST"
					Debugmsg=$Debugmsg"telcfg:settings/Foncontrol/User$FONuser/Name=$3&sid=$SID"
					;;
	"WLAN")  		LOGIN				# sh FritzBox.sh WLAN state CUX2801234:1
					if [ $2 = "0" ] || [ $2 = "1" ]; then
					    PerformPOST "wlan:settings/ap_enabled=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then 
						get_WLAN_state
						set_CUxD_state "$stateWLAN" $1 $3 $stateWLAN
					fi
					;;
	"WLAN5")		LOGIN
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						PerformPOST "wlan:settings/ap_enabled_scnd=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then
						get_WLAN5_state
						set_CUxD_state "$stateWLAN5" $1 $3 $stateWLAN5
					fi
					;;
	"WLANGast")		LOGIN
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						PerformPOST "wlan:settings/guest_ap_enabled=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then
					    get_WLANGast_state
						if [ $stateWLANGast = "0" ] || [ $stateWLANGast = "1" ]; then
							set_CUxD_state "$stateWLANGast" $1 $3 $stateWLANGast
						else
							get_WLAN_state
							get_WLAN5_state
							if [[ $stateWLAN = "0" && $stateWLAN5 = "0" ]] || [[ $stateWLAN = "0" && $stateWLAN5 = "" ]]; then
								set_CUxD_state "$stateWLANGast" $1 $3 0
								Debugmsg=$Debugmsg"$IP -> $1: WLAN / WLAN5 inaktiv, daher keine Statusabfrage moeglich!\n"
								logger -i -t $0 -p 6 "$IP -> $1: WLAN / WLAN5 inaktiv, daher keine Statusabfrage moeglich!"
							fi
						fi
					fi
					;;						
	"UMTS") 		LOGIN
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						PerformPOST "umts:settings/enabled=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then 
						get_UMTS_state
						set_CUxD_state "$stateUMTS" $1 $3 $stateUMTS
					fi
					;;
	"CallThrough") 	LOGIN
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						PerformPOST "telcfg:settings/CallThrough/Active=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then 
						get_CallThrough_state
						set_CUxD_state "$stateCallThrough" $1 $3 $stateCallThrough
					fi
					;;
	"DECT")			LOGIN
					if [ $2 = "0" ] || [ $2 = "1" ]; then
						PerformPOST "dect:settings/enabled=$2&sid=$SID" "POST"
					elif [ $2 = "state" ]; then 
						get_DECT_state
						set_CUxD_state "$stateDECT" $1 $3 $stateDECT
					fi
					;;
	"WLANNacht")	LOGIN
					PerformPOST "wlan:settings/night_time_control_no_forced_off=$2&sid=$SID" "POST"
					;;
	"WLANAnwesend") get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 1" -B26 | grep "active = 1" -A24 | grep " name = " | sed -e 's/name =//' -e 's/,//')
					#anwesenheit=$(grep "wlan = 1" -B26 $network_user_devices | grep "active = 1" -A24 | grep " name = " | sed -e 's/name =//' -e 's/,//')
					echo "ausgabe: $anwesenheit"
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 erkannt\n"
						SetCCUVariable $3 "1"
					else
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 nicht erkannt\n"
						SetCCUVariable $3 "0"
					fi
					Debugmsg=$Debugmsg"Alle WLAN-Geräte: $anwesenheit \n"
					;;
	"WLANOnline")	get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 1" -B26 | grep "online = 1" -B1 |grep name | sed -e 's/name =//' -e 's/,//')
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 erkannt\n"
						SetCCUVariable $3 "1"
					else
						Debugmsg=$Debugmsg"WLAN-Anwesend: $2 nicht erkannt\n"
						SetCCUVariable $3 "0"
					fi
					Debugmsg=$Debugmsg"Alle WLAN-Geräte: $anwesenheit \n"
					;;
	"LANAnwesend") 	get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 0" -B26 | grep "active = 1" -A24 | grep " name = " | sed -e 's/name =//' -e 's/,//')
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 erkannt\n"
						SetCCUVariable $3 "1"
					else
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 nicht erkannt\n"
						SetCCUVariable $3 "0"
					fi
					Debugmsg=$Debugmsg"Alle LAN-Geräte: $anwesenheit \n"
					;;
	"LANOnline") 	get_network_user_devices
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					anwesenheit=$(grep '_node = landevice' -A27 -B2 $network_user_devices | grep "wlan = 0" -B26 | grep "online = 1" -B1 | grep name | sed -e 's/name =//' -e 's/,//')
					anwesenheit1=$(echo $anwesenheit | grep "$2" )
					if [ "$anwesenheit1" != "" ]; then
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 erkannt\n"
						SetCCUVariable $3 "1"
					else
						Debugmsg=$Debugmsg"LAN-Anwesend: $2 nicht erkannt\n"
						SetCCUVariable $3 "0"
					fi
					echo $anwesenheit
					Debugmsg=$Debugmsg"Alle LAN-Geräte: $anwesenheit \n"
					;;
	"WakeOnLan")	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/network_user_devices.lua?sid=$SID \n"
					wol=$($WEBCLIENT "$FritzBoxURL/net/network_user_devices.lua?sid=$SID" | grep '"name"] = ' -B2 | grep $2 -B2 |grep mac | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' -e 's/mac =//' -e 's/,//' -e 's/^[ \t]*//;s/[ \t]*$//')
					Debugmsg=$Debugmsg"Debug:"$wol"\n"
					if [ "$wol" != "" ]; then
						Debugmsg=$Debugmsg"WOL-MAC: $2 erkannt: $wol\n"
						./ether-wake $wol
					else
						Debugmsg=$Debugmsg"WOL-MAC: $2 nicht erkannt\n"
					fi
					;;
	"NACHTRUHE") 	LOGIN
					PerformPOST "box:settings/night_time_control_enabled=$2&sid=$SID" "POST";;
	"KLINGELSPERRE") LOGIN
					PerformPOST "box:settings/night_time_control_ring_blocked=$2&sid=$SID" "POST";;
	"RUFUMLEITUNG") LOGIN 
					PerformPOST "telcfg:settings/CallerIDActions$2/Active=$3&sid=$SID" "POST";;
	"Diversity")	LOGIN 
					PerformPOST "telcfg:settings/Diversity$2/Active=$3&sid=$SID" "POST";;	
	"ANRUFEN") 		LOGIN 
					PerformPOST "telcfg:command/Dial=$2&sid=$SID" "POST";;
	"DECT200")		LOGIN
					PerformPOST "sid=$SID&command=SwitchOnOff&id=$2&value_to_set=$3&xhr=1" "POST" "/net/home_auto_query.lua" "DECTCOMMAND0.txt";;
	"DECT200Status") LOGIN
					PerformPOST "sid=$SID&command=AllOutletStates&xhr=0" "POST" "/net/home_auto_query.lua" "DECT200Status0.txt"
					PerformPOST "sid=$SID&command=EnergyStats_10&id=$2&xhr=0" "POST" "/net/home_auto_query.lua" "DECT200ENERGIE0.txt";;
	"DECT200Energie") LOGIN
					Debugmsg=$Debugmsg"DECT200Energie $2 \n"
					Debugmsg=$Debugmsg"$FritzBoxURL/net/home_auto_query.lua?sid=$SID&command=EnergyStats_10&id=$2&xhr=0 \n"
					MM_Value_Power=$($WEBCLIENT "$FritzBoxURL/net/home_auto_query.lua?sid=$SID&command=EnergyStats_10&id=$2&xhr=0" | sed -e 's/[{}]/''/g' | awk -v RS=',"' -F: '/^MM_Value_Power/ {print $2}' | sed -e 's/"//g' | sed -e 's/ //g')
					Debugmsg=$Debugmsg"MM_Value_Power von $2 = $MM_Value_Power \n"
					SetCCUVariable $3 $MM_Value_Power
					;;
	"AB") 			if [ $3 = "0" ] || [ $3 = "1" ]; then
						LOGIN
						PerformPOST "tam:settings/TAM$2/Active=$3&sid=$SID" "POST"
						get_AB_temp
					elif [ $3 = "state" ]; then 
						get_AB_state $2
						set_CUxD_state "$stateAB" $1$2 $4 $stateAB
					fi
					;;
	"Status-AB") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/fon_devices/tam_list.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/fon_devices/tam_list.lua?sid=$SID" | grep '"Active"' -B1 | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' | grep "\[$2\]" -A1)
					if echo $status | grep -q "Active = 1" ; then 
						Debugmsg=$Debugmsg"Status-AB: $2 aktiv\n"
						SetCCUVariable $3 "1"
					else
						Debugmsg=$Debugmsg"Status-AB: $2 deaktiviert\n"
						SetCCUVariable $3 "0"
					fi
					;;
	"Anrufliste") 	LOGIN
					$WEBCLIENT "$FritzBoxURL/fon_num/foncalls_list.lua?sid=$SID&csv="  "$FritzBoxU RL/fon_num/foncalls_list.lua?sid=$SID&csv=" >$ANRUFLIST 
					;;
	"Anrufliste2CCU")
					LOGIN
					$WEBCLIENT "$FritzBoxURL/fon_num/foncalls_list.lua?sid=$SID&csv=" >$ANRUFLIST 
					out="<table id='fritz'>"
					count=0
					anzahl=`expr $3 + 1`
					while read line; do
						if [ $count -eq $anzahl ]; then
							break       	   
						fi
						if [ "$count" -gt "0" ]; then
							typ=`echo "$line" | cut -f1 -d';'`
							datum=`echo "$line" | cut -f2 -d';'`
							name=`echo "$line" | cut -f3 -d';'`
							rufnummer=`echo "$line" | cut -f4 -d';'`
							nebenstelle=`echo "$line" | cut -f5 -d';'`
							eigene=`echo "$line" | cut -f6 -d';'`
							dauer=`echo "$line" | cut -f7 -d';'`
							out=$out"<tr><td class='fritz_"$typ"'/><td>"$datum"</td><td>"$name"</td><td>"$rufnummer"</td><td>"$nebenstelle"</td><!--<td>"$eigene"</td>--><td>"$dauer"</td></tr>"
						fi
						count=`expr $count + 1` 
					done < $ANRUFLIST
					out=$out"</table>"
					urlencode=$(echo "$out" | sed -e 's/%/%25/g' -e 's/ /%20/g' -e 's/!/%21/g' -e 's/"/%22/g' -e 's/#/%23/g' -e 's/\$/%24/g' -e 's/\&/%26/g' -e 's/'\''/%27/g' -e 's/(/%28/g' -e 's/)/%29/g' -e 's/\*/%2a/g' -e 's/+/%2b/g' -e 's/,/%2c/g' -e 's/-/%2d/g' -e 's/\./%2e/g' -e 's/\//%2f/g' -e 's/:/%3a/g' -e 's/;/%3b/g' -e 's//%3e/g' -e 's/?/%3f/g' -e 's/@/%40/g' -e 's/\[/%5b/g' -e 's/\\/%5c/g' -e 's/\]/%5d/g' -e 's/\^/%5e/g' -e 's/_/%5f/g' -e 's/`/%60/g' -e 's/{/%7b/g' -e 's/|/%7c/g' -e 's/}/%7d/g' -e 's/~/%7e/g')
					$WEBCLIENT "http://$HOMEMATIC/addons/webmatic/cgi/set.cgi?id=$2&value=$urlencode"
					;;
	"Status-UMTS") 	LOGIN
					get_UMTS_state
					if [ $stateUMTS = "0" ] || [ $stateUMTS = "1" ] ; then
						Debugmsg=$Debugmsg"$1: $stateUMTS\n"
						SetCCUVariable $2 $stateUMTS
					else
						Debugmsg=$Debugmsg"$1: Fehler\n"
					fi
					;;
	"Status-DECT") 	LOGIN
					get_DECT_state
					if [ $stateDECT = "0" ] || [ $stateDECT = "1" ] ; then
						Debugmsg=$Debugmsg"$1: $stateDECT\n"
						SetCCUVariable $2 $stateDECT
					else
						Debugmsg=$Debugmsg"$1: Fehler\n"
					fi
					;;
	"Status-DECT200") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/net/home_auto_query.lua?sid=$SID&command=AllOutletStates&xhr=0 \n"
					status=$($WEBCLIENT "$FritzBoxURL/net/home_auto_query.lua?sid=$SID&command=AllOutletStates&xhr=0" | grep 'DeviceSwitchState' | sed -e 's/\["//g' -e 's/\"]//g' -e 's/\"//g' -e 's/,//' -e 's/^[ \t]*//;s/[ \t]*$//' | grep -Eo "$2.{52}" | grep -Eo "DeviceSwitchState_*.{5}" | grep -Eo ":.{2}" | sed -e 's/: //')
					if [ "$status" = "1" ] ; then 
						Debugmsg=$Debugmsg"Status-DECT: Dect $2 an\n"
						SetCCUVariable $3 "1"
					else
						Debugmsg=$Debugmsg"Status-DECT: Dect $2 aus\n"
						SetCCUVariable $3 "0"
					fi
					;;
	"Status-IP") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID" | grep 'connection0:status/ip')
					if echo $status | grep -q '"-"' ; then 
						Debugmsg=$Debugmsg"Status-IP: - \n"
						SetCCUVariable $2 "-"
					else
						ip=$(echo $status |  sed -e 's/= //;s/",//g;s/"*//g;s/\[connection0:status\/ip\]//g')
						Debugmsg=$Debugmsg"Status-IP: $ip \n"
						SetCCUVariable $2 $ip
					fi
					Debugmsg=$Debugmsg"Status-IP: $ip\n"
					;;										
	"Status-KLINGELSPERRE") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/system/ring_block.lua?sid=$SID\n"
					status=$($WEBCLIENT "$FritzBoxURL/system/ring_block.lua?sid=$SID" | grep 'night_time_control_enabled' | grep -Eo "=.{3}" | sed -e 's/\"//g' -e 's/= //')
					if [ "$status" = "1" ] ; then 
						Debugmsg=$Debugmsg"Status-KLINGELSPERRE: an\n"
						SetCCUVariable $2 "1"
					else
						Debugmsg=$Debugmsg"Status-KLINGELSPERRE: aus\n"
						SetCCUVariable $2 "0"
					fi
					;;
	"Status-Verbindung") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID" | grep 'connection0:status/ip')
					if echo $status | grep -q '"-"' ; then 
						Debugmsg=$Debugmsg"Status-Verbindung: nicht verbunden\n"
						SetCCUVariable $2 "0"
					else
						Debugmsg=$Debugmsg"Status-Verbindung: verbunden\n"
						SetCCUVariable $2 "1"
					fi
					;;
	"Status-Verbindungszeit") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/internet/inetstat_monitor.lua?sid=$SID" | grep "connection0:status/conntime_date" -A1)
					status2=$(echo -e $status | sed -e 's/"connection0:status\/conntime_date"//;s/"connection0:status\/conntime_time"//;s/\[\] =//g;s/"//g;s/,//g;s/\n//g;s/^ //g;s/ / /g;s/\./-/g;s/ /%20/g' | sed ':a;N;$!ba;s/\n//g')
					if echo $status2 | grep -q '\"-\"' ; then 
						Debugmsg=$Debugmsg"Status-Verbundindungszeit: - \n"
						SetCCUVariable $2 "-"
					else
						Debugmsg=$Debugmsg"Status-Verbundindungszeit: $status2 \n"
						SetCCUVariable $2 "$status2"
					fi
					Debugmsg=$Debugmsg"Status-Verbundindungszeit: $status2\n"					
					;;					
	"Status-WLAN") 	LOGIN
					get_WLAN_state
					if [ $stateWLAN = "0" ] || [ $stateWLAN = "1" ] ; then
						Debugmsg=$Debugmsg"$1: $stateWLAN an\n"
						SetCCUVariable $2 $stateWLAN
					else
						Debugmsg=$Debugmsg"$1: Fehler\n"
					fi
					;;
	"Status-WLAN5") LOGIN
					get_WLAN5_state
					if [ $stateWLAN5 = "0" ] || [ $stateWLAN5 = "1" ] ; then
						Debugmsg=$Debugmsg"$1: $stateWLAN5\n"
						SetCCUVariable $2 $stateWLAN5
					else
						Debugmsg=$Debugmsg"$1: Fehler\n"
					fi
					;;
	"Status-WLANGast") 	LOGIN
                    get_WLANGast_state
					if [ $stateWLANGast = "0" ] || [ $stateWLANGast = "1" ] ; then
						Debugmsg=$Debugmsg"$1: $stateWLANGast\n"
						SetCCUVariable $2 $stateWLANGast
					else
						Debugmsg=$Debugmsg"$1: Fehler\n"
					fi
					;;
	"Status-WLANZeitschaltung") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/system/wlan_night.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/system/wlan_night.lua?sid=$SID" | grep 'name="active" id="uiActive"')
					if echo $status | grep -q 'id="uiActive" checked>' ; then
						Debugmsg=$Debugmsg"Status-WLANZeitschaltung: an\n"
						SetCCUVariable $2 "1"
					else
						Debugmsg=$Debugmsg"Status-WLANZeitschaltung: aus\n"
						SetCCUVariable $2 "0"
					fi
					;;
	"Status-Rufumleitung") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/fon_num/rul_list.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/fon_num/rul_list.lua?sid=$SID" | grep '"telcfg:settings/CallerIDActions' -A1)
					if echo $status | grep -q '\[1\]' ; then
						Debugmsg=$Debugmsg"Status-Rufumleitung: aktiv\n"
						SetCCUVariable $2 "1"
					else
						Debugmsg=$Debugmsg"Status-Rufumleitung: inaktiv\n"
						SetCCUVariable $2 "0"
					fi
					;;
	"Weckruf") 		LOGIN 
					PerformPOST "telcfg:settings/AlarmClock$2/Active=$3&sid=$SID" "POST";;	
	"Status-Weckruf") 	LOGIN
					Debugmsg=$Debugmsg"URL: $FritzBoxURL/fon_devices/alarm.lua?sid=$SID \n"
					status=$($WEBCLIENT "$FritzBoxURL/fon_devices/alarm.lua?sid=$SID&tab=$2" | grep "telcfg:settings/AlarmClock$2/Active")
					if echo $status | grep -q '"1"' ; then
						Debugmsg=$Debugmsg"Status-Weckruf: aktiv\n"
						SetCCUVariable $3 "1"
					else
						Debugmsg=$Debugmsg"Status-Weckruf: inaktiv\n"
						SetCCUVariable $3 "0"
					fi
					;;
	"reboot") 		LOGIN
					PerformPOST "logic:command/reboot=../gateway/commands/saveconfig.html&sid=$SID" "POST" 
					PerformPOST "security:command/logout=1&sid=$SID" "POST";;
	*) 				Debugmsg=$Debugmsg"MAIN :  ERROR - Bitte wie folgt aufrufen: \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh BEFEHL WERT (0=aus|1=ein) \n"
					Debugmsg=$Debugmsg"        Verfuegbar:  \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|state CUX2801xxx:x] -> ein/aus an das sendende Gerät\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|state CUX9001xxx:x] -> ein/aus an CUxD (90)State-Monitor Device\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|state1 CUX2801xxx:x] - SysVar [CUX2801xxx:x-Status] -> Werteliste: nicht erreichbar;erreichbar;unbekannt\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|state1-p CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status] [CUX2801xxx:x-Leistung]\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|state1-t CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status]  [CUX2801xxx:x-Temperatur]\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|state1-pt CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status] [CUX2801xxx:x-Leistung] [CUX2801xxx:x-Temperatur]\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|state1-pts CUX2801xxx:x] - SysVar: [CUX2801xxx:x-Status] [CUX2801xxx:x-Leistung] [CUX2801xxx:x-Temperatur] [CUX2801xxx:x-Schaltzustand]\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|power CUX2801xxx:x] - SysVar [CUX2801xxx:x-Leistung] -> Zahl\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|power1 CUX9000xxx:x] - CUxD (90)Transform Device \n"	
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|temperature CUX2801xxx:x] - SysVar [CUX2801xxx:x-Temperatur] -> Zahl\n"		
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|temperature1 CUX9000xxx:x] - CUxD (90)Transform Device \n"	
					Debugmsg=$Debugmsg"        ./FritzBox.sh FB-AHA [AIN|MAC] [0|1|temperature2 CUX9002xxx:x] - CUxD (90)Thermostat Device \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FON-alarm [610|611|...] [1|2|3] [0|1|...] [Text] -> FritzBox.sh FON-alarm 610 1 8 Hallo%20Welt \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FON-RingTone [610|611|...] [0|1|...] ->  sh FritzBox.sh FON-RingTone 610 16 (16=lautlos, 3=standard,...)\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh FON-Name [610|611|...] [Name] -> FritzBox.sh FON-Name 610 Name\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLAN [0|1|state CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLAN5 [0|1|state CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLANGast [0|1|state CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLANNacht [0|1] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLANAnwesend [Name des WLAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh WLANAnwesend Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WLANOnline [Name des WLAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh WLANOnline Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh LANAnwesend [Name des LAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh LANAnwesend Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh LANOnline [Name des LAN Geraetes] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh LANOnline Geraet CCUVariable \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh WakeOnLan [Name des LAN Geraetes] - Beispiel: FritzBox.sh WakeOnLan Geraetename \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh DECT [0|1|state  CUX2801xxx:x] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh UMTS [0|1|state  CUX2801xxx:x]] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh CallThrough [0|1|state  CUX2801xxx:x]] \n"	
					Debugmsg=$Debugmsg"        ./FritzBox.sh NACHTRUHE [0|1] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh KLINGELSPERRE [0|1] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh ANRUFEN [(Telefonnummer z.B. **610)] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh RUFUMLEITUNG [0|1|2|3(Rufumleitung)] [0|1] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Diversity [0|1|2|3(Rufumleitung)] [0|1] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh DECT200 [16|17|18|19] [0|1] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh DECT200Energie [Nummer des Aktors:16|17|18|19] [Name der Variable in der CCU] - Beispiel: FritzBox.sh DECT200Energie 16 DECT200 \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh AB [0|1|2...-9] [0|1|state CUX2801xxx:x] - Beispiel schaltet den 2. AB ein: FritzBox.sh AB 1 1\n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-AB [1|2...-10] [Name der logischen Variable (Bool)in der CCU] - Beispiel Status 2. AB : FritzBox.sh Status-AB 2 CCUVariableAB2 \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Anrufliste \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Anrufliste2CCU [0000(HOMEMATIC Webmatic SYSVAR ID)] [Anzahl Eintraege] \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-Rufumleitung [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-Rufumleitung RufumleitungVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-DECT [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-DECT DECTanausVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-UMTS [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-UMTS UMTSanausVariableCCU \n"	
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-DECT200 [16|17|18|19] [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-DECT200 16 DECT16VariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-IP [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh SStatus-IP ExterneIPVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-KLINGELSPERRE [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-KLINGELSPERRE KLINGELSPERREVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-Verbindung [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-Verbindung InternetverbundenVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-Verbindungszeit [Name der logischen Variable (Zeichenkette)in der CCU] Beispiel: FritzBox.sh Status-Verbindungszeit InternetVerbindungszeitVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-WLAN [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-WLAN WLANanausVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-WLAN5 [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-WLAN5 WLAN5anausVariableCCU \n"					
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-WLANGast [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh SStatus-WLANGast WLANGastanausVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-WLANZeitschaltung  [Name der logischen Variable (Bool)in der CCU] Beispiel: FritzBox.sh Status-WLANZeitschaltung WLANZeitschaltungVariableCCU \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Weckruf [0|1|2] [0|1] - Beispiel: Schaltet den ersten Weckruf ein  FritzBox.sh Weckruf 0 1 \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh Status-Weckruf [0|1|2] [Name der logischen Variable (Bool)in der CCU] - Beispiel: FritzBox.sh Status-Weckruf 0 CCUvarWeckruf1 \n"
					Debugmsg=$Debugmsg"        ./FritzBox.sh reboot \n"
					EndFritzBoxSkript 4 "Falscher-Parameter-Aufruf-$1-$2-$3-$4";;
esac
EndFritzBoxSkript 0 "Erfolgreich"
